/*
 * This file is part of the AdvanceMAME project
 *
 * Copyright (C) 1999-2000 Andrea Mazzoleni
 *
 * The contents of this file are free for non-commercial use.
 * Any commercial use is forbidden.
 */

#ifndef __MENU_H
#define	__MENU_H

#include "game.h"

enum game_sort_t {
	sort_by_group,
	sort_by_name,
	sort_by_root_name,
	sort_by_time,
	sort_by_year,
	sort_by_manufacturer,
	sort_by_type,
	sort_by_size
};

enum tristate_t {
	include,
	exclude,
	exclude_not
};

struct menu_state {
	group_container include_group; // gruppi di inclusione
	type_container include_type; // gruppi tipo

	tristate_t exclude_neogeo;
	tristate_t exclude_clone;
	tristate_t exclude_bad;
	tristate_t exclude_missing;
	tristate_t exclude_vector;

	string snap; // directory per gli snapshot
	int pos_base; // posizione di inizio schermo
	int pos_rel; // posizione relativa del cursore
	const game* pgame; // gioco alla posizione del cursore, ==0 se nessuno
	const game* pclone; // clone scelto, ==0 se nessuno
	string fast; // stringa per selezione veloce
	game_sort_t sort_mode; // tipo di ordinamento
	bool backdrop_merge; // usa il backdrop come sfondo

	string last_game; // last game selected

	unsigned idle_start;
	unsigned idle_start_rep;
	unsigned idle_move;
	unsigned idle_move_rep;

	merge_t merge; // merge type
};

int run_menu(const game_set& gar, menu_state& rs, bool flipxy);
void run_sort(menu_state& rs);
void run_exclude(menu_state& rs);
void run_type(menu_state& rs, const type_container& typ);
void run_type_move(menu_state& rs, const type_container& typ);
void run_group(menu_state& rs, const group_container& grp);
void run_group_move(menu_state& rs, const group_container& grp);
void run_clone(menu_state& rs, const game_set& gar);

#endif
