#ifndef __DRIVER_H
#define	__DRIVER_H

typedef unsigned char BYTE;
typedef unsigned short WORD;
typedef unsigned long DWORD;

typedef struct {
	/* Horizontal CRTC */
	int HTotal;
	int HDisp;
	int HBStart;
	int HSStart;
	int HSEnd;
	int HBEnd;

	/* Vertical CRTC, doubled in dobulescan, halved in interlaced */
	int VTotal;
	int VDisp;
	int VBStart;
	int VSStart;
	int VSEnd;
	int VBEnd;

	int width; /* Size of the mode */
	int height;

	int hpolarity;
	int vpolarity;
	int doublescan; /* Doublescan flag */
	int interlace; /* Interlace flag */
	int interlaceratio; /* Interlace ratio, 0-100 */

	int bits; /* Bits per pixel */

	/* Clocks */
	long dotclockHz;
	long horzHz;
	long vert001Hz;
} CRTCPARAM;

void SetGenericVGARegister(CRTCPARAM *cp);
long CalcDotclock(long Vert001Hz, int HTotal, int VTotal, int interlace);
long CalcVert001Hz(long dotclockHz, int HTotal, int VTotal, int interlace);
long CalcHorizontalHz(long dotclockHz, int HTotal);

void DispCrtcParam(CRTCPARAM *cp);

DWORD BitMov(DWORD dstdata, int dstbitpos, DWORD srcdata, int srcbitpos);
void _out(int edx, BYTE al);
BYTE _in(int edx);
void _outb(int edx, BYTE al);
BYTE _inb(int edx);
void _outw(int edx, WORD ax);
WORD _inw(int edx);
void _outl(int edx, DWORD eax);
DWORD _inl(int edx);

int GetCrtcAddress(void);
BYTE GetSeqReg(BYTE);
void SetSeqReg(BYTE, BYTE);
BYTE GetCrtcReg(BYTE);
void SetCrtcReg(BYTE, BYTE);
BYTE GetAtrbData(BYTE);
void SetAtrbData(BYTE, BYTE);
BYTE GetGraphReg(BYTE);
void SetGraphReg(BYTE, BYTE);
int GetSeqDivider(void);
void SetSeqDivider(BYTE);
void SetHVPolarity(int HPolar, int VPolar);
void DisableGenerateSignal(void);
void EnableGenerateSignal(void);
int GetMode15KHz(CRTCPARAM *cp);

#define logerror video_log
#define	_create_linear_mapping card_create_linear_mapping
#define	_remove_linear_mapping card_remove_linear_mapping
#define _create_selector card_create_selector
#define _remove_selector card_remove_selector
extern int _create_linear_mapping(unsigned long *linear, unsigned long physaddr, int size);
extern int _create_selector(int *segment, unsigned long linear, int size);
extern void _remove_linear_mapping(unsigned long *linear);
extern void _remove_selector(int *segment);

#include "screen.h"

#endif
