#ifndef __VIDEO_H
#define __VIDEO_H

#define STRETCH_NONE 0 /* no at all */
#define	STRETCH_INTEGER_XY 1 /* only integer strech x2,x3,... */
#define	STRETCH_INTEGER_X_FRACTIONAL_Y 2 /* integer on x, fractional on y */
#define	STRETCH_FRACTIONAL_XY 3 /* fractional on x and y */
extern int stretch_request; /* type of stretch */

extern int video_vsync_request; /* boolean */
extern int wait_vsync_request; /* boolean */
extern int use_triplebuf_request; /* boolean */

extern int frameskip; /* number of frame to skip, ==0 if autoframeskip == true */
extern int autoframeskip; /* boolean */

extern char resolution_request[];
extern int scanlines; /* boolean */

extern int skiplines_request; /* centering value for screen, -1 for auto centering */
extern int skipcolumns_request;

extern float osd_gamma_correction; /* real value for gamma correction */

extern int brightness; /* brightness 1-100 */

extern int dirty_request; /* boolean, -1 == auto */

/* Trasformation at blit level */
extern int blit_orientation; /* ORIENTATION_ mask */

/* Special effect */
#define COMBINE_AUTO -1
#define COMBINE_NONE VIDEO_COMBINE_NONE
#define COMBINE_MAX VIDEO_COMBINE_MAX
#define COMBINE_MEAN VIDEO_COMBINE_MEAN
#define COMBINE_FILTER VIDEO_COMBINE_FILTER
extern int blit_combine_request;

/* Return the resolution used by the specified game */
char* get_game_resolution(const struct GameDriver* driver);

#endif
